alfa=ALFA{find(max(temp)==temp)};
beta=BETA{find(max(temp)==temp)};

alfa2=sort(alfa);

poz=[];
for i=1:length(alfa)
    poz=[poz find(alfa2(i)==alfa)]       
end
beta2=beta(poz);

xopt(1)=min(MIN);
xopt(length(alfa)+1)=max(MAX);

for i=1:length(alfa)-1
    xopt(i+1)=(beta2(i+1)-beta2(i))/(alfa2(i)-alfa2(i+1));
end


% clear;close all;clc
%% uloha regulacie

% proces
optim=[];
A = sysStruct.A;
B = sysStruct.B;
for i=1:5
% pociatocna podmienka
xt = xopt(i);
% predikcny horizont
N=5;
% optimalizacna premenna
nx = size(A,2);
nu = size(B,2);
U = sdpvar(N*nu,1);
% vahove matice
Q_x = eye(nx,nx);
tQx = kron(eye(N),Q_x);
Q_u = eye(nu,nu);
tQu = kron(eye(N),Q_u);
% A s tildou
%  tA = [eye(nx); A; A^2];
tA=[eye(size(A))];
for i=1:N-1
    tA = [tA; A^(i)];
end 
tB = [repmat(zeros(nx,nu),1,N)]; %od sana
temp = [B tB(:,(1:end-nu))];
tB = [tB;temp];
for i = 1:N-2
    temp = [A^i*B tB(i*nx+1:end,(1:end-nu))];
    tB = [tB;temp];
end
% ohranicenia
xmin=[-5];
xmax=[5];
umin=-1;
umax=1;
H = [eye(nx); -eye(nx)]; K = [xmax; -xmin];
L = [eye(nu); -eye(nu)]; M = [umax; -umin];
tH = kron(eye(N), H); tK = kron(ones(N, 1), K);
tL = kron(eye(N), L); tM = kron(ones(N, 1), M);
objective = U'*(tB'*tQx*tB + tQu)*U + ...
               2*xt'*tA'*tQx*tB*U;
constraints = [ tH*tB*U <= (tK - tH*tA*xt); ...
                   tL*U <= tM ];
info = solvesdp(constraints, objective)
 if info.problem~= 0, error('Problem infeasible'),end
X = reshape(tA*xt + tB*double(U), nx, N)';
Uopt = reshape(double(U), nu, N)';
[X Uopt];
optim=[optim Uopt(1)];
end
U=[];
for i=1:5
    temp23=Regions(i);
u=optim(i)*[min(temp23{1}) max(temp23{1});1 1]^-1*[xopt(i);1];
U=[U u];
end

clear VU VV Vu
for i=1:length(xopt)-1
VV{i}=[xopt(i) xopt(i+1)]';
end

for i=1:length(optim)-1
Vu{i}=[optim(i) optim(i+1)]';
end

for i = 1:length(VV)
X = [VV{i}'; ones(1,length(VV{i}))];
U = [Vu{i}'];
C = U*X^-1;
REGULATOR{i}=C';
end

zakon=[];
xzakon=[];
for i=1:length(REGULATOR)
    xzakon=[xzakon;xopt(i);xopt(i+1)];
    zakon=[zakon;REGULATOR{i}(1)*xopt(i)+REGULATOR{i}(2);REGULATOR{i}(1)*xopt(i+1)+REGULATOR{i}(2);];
end
figure
plot(xzakon,zakon)
axis([min(xzakon)-0.5 max(xzakon)+0.5 min(zakon)-0.5 max(zakon)+0.5])
title('zjednoduseny zakon riadenia')
xlabel('x')
ylabel('u(x)')
for i=1:length(REGULATOR)
fprintf('%d.region alfa=%6.4f beta=%6.4f\n',i,REGULATOR{i}(1),REGULATOR{i}(2));
end

