 clear all, close all, clc
%% zadany system
lti_1d_unstable;
%% pripravy data pre zvoleny system
prepare_data;
%% vykresli hornu a dolnu medzu
hold on
plot_pwa(Jlow); hold on; plot_pwa(Jup);
%% pocet regionov
n_R = length(Jlow.R);
n_v = length(extreme(Jlow.R(1)));
MIN=[];MAX=[];
for i=1:n_R
MIN=[MIN min(extreme(Jlow.R(i)))];
MAX=[MAX max(extreme(Jlow.R(i)))];
end

%% zoradenie regionov
TEMP = [];
for i=1:n_R
TEMP = [TEMP extreme(Jlow.R(i))];
end
TEMP2=[];
for i=1:size(TEMP,2)
    TEMP2(1,i)=max(extreme(Jlow.R(i)));
    TEMP2(2,i)=min(extreme(Jlow.R(i)));
end
SORT=sort(TEMP2(2,:));
POSITION=[];
for i=1:n_R
POSITION=[POSITION find(SORT(i)==TEMP2(2,:))];
end
n_v_d=[];
n_v = length(extreme(Jlow.R(1)));
%% 
for i=1:n_R
    C_low{i}=Jlow.C{POSITION(i)};
    D_low{i}=Jlow.D{POSITION(i)};
    C_up{i}=Jup.C{POSITION(i)};
    D_up{i}=Jup.D{POSITION(i)};
    Regions{i}=extreme(Jlow.R(POSITION(i)));
end    
%% simulacia
tic,
temp=[];
OBJ=-1;
i=1;
approx=2;
while OBJ<=-10^-8
[alfa,beta]=prediction3(C_low,D_low,C_up,D_up,Regions,n_R,n_v_d,n_v,approx);
[OBJ,X]=certikikat(alfa,beta,C_low,D_low,Jlow,POSITION,n_R);    
if OBJ<0
        n_v_d=[n_v_d X];
else
    break;
end
temp=[temp OBJ];
    ALFA{i}=alfa;
    BETA{i}=beta;
i=i+1
if i>10
    break;
end
end
toc
hold on

% x=min(MIN):0.1:max(MAX);
% 
% for i=1:length(ALFA)
%     figure
%     plot_pwa(Jlow)
%     hold on
%     plot_pwa(Jup)
% 
%     for j=1:length(ALFA{1})
%         hold on
%         plot(x,ALFA{i}(j)*x+BETA{i}(j),'r','LineWidth',2)
%     end
% end

run exp_easy